/* Copyright (C) 1999 Dustin Ward <Vortex@qconline.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef MODSUPPORT

#include <dlfcn.h>
#include "structs.h"
int MyFinish ();
aModuleList *modlist = NULL;
int numcoms(int num)
{
     aModuleList *modptr;
     for (modptr = modlist; modptr; modptr = modptr->next)
     {
	modlist->numcommands=num;
     }
   return 0;
}
int
insmod (char *name)
{
  aModuleList *modptr;
  void *handle;
  Function *Finish;
  char buf[50];
  if(getenv("DEMCD_MODPATH") != NULL)
     sprintf (buf, "%s/%s.so", getenv ("DEMCD_MODPATH"), name);
  else
  sprintf (buf, "%s/.mods/%s.so", getenv ("HOME"), name);

  for (modptr = modlist; modptr; modptr = modptr->next)
    {
      if (!strcasecmp (name, modptr->name))
	{
	  printf ("Module already Loaded!\n");
	  return 0;
	}
    }
  handle = dlopen (buf, RTLD_NOW | RTLD_GLOBAL);
  if (!handle)
    {
      fprintf (output, "Error: %s\n", dlerror ());
      return 0;
    }
  func = dlsym (handle, "init_module");
   if (dlerror() != NULL)
    {
      fprintf (output, "%s\n", dlerror());
      return 0;
    }
    Finish = dlsym(handle, "finish_mod");
   if (dlerror() != NULL)
    {
        Finish=MyFinish;
    }
  modptr = (aModuleList *) malloc (sizeof (aModuleList));
  modptr->next = modlist;
  modptr->prev = NULL;
  if (modlist)
    modlist->prev = modptr;
  modptr->handle = handle;
  modptr->Finish = Finish;
  modptr->name = strdup (name);
  modlist = modptr;
  func ();
  return 0;
}
int
com_rmmod (DCD *dcd)
{
  int x=0;
  int num=1;
  aModuleList *modptr;
  for (modptr = modlist; modptr; modptr = modptr->next)
    {
      if (!strcasecmp (dcd->arg, modptr->name))
	{
	  num=modptr->numcommands;
	  if (num==0) num=1;
	  for(x=0;x<num;x++)
	     fixlist();
	  modptr->Finish();
     	  dlclose (modptr->handle);
	  free (modptr->name);
	   if (modptr->prev)
	    modptr->prev->next = modptr->next;
	  else
	    modlist = modptr->next;
	  if (modptr->next)
	    modptr->next->prev = modptr->prev;
      	   free (modptr);
	  return 0;
	}
    }
  return 0;
}
int
com_lsmod ()
{
  aModuleList *modptr;
  printf ("Currently Loaded Modules\n");
  printf ("------------------------\n");
  for (modptr = modlist; modptr; modptr = modptr->next)
    {
      printf ("%s\n", modptr->name);
    }
  return 0;
}

int MyFinish ()
{
   return 0;
}
#endif
